from .download import download_zip
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "assets.zip",down_path)

bl_info = {
    "name" : "Stamp It",
    "author" : "Bee Bee", 
    "description" : "More free stuff for Blender: https://t.me/cgplugin",
    "blender" : (3, 0, 0),
    "version" : (1, 0, 0),
    "location" : "Shader Editor N Panel",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
from bpy.app.handlers import persistent
import os
from bpy_extras.io_utils import ImportHelper, ExportHelper


addon_keymaps = {}
_icons = None
stamp_it = {'sna_newnodecreatedid': '', }


def sna_object_select_set_ACDF7_55FB4(Object, select_set):
    obj = Object
    boolien = select_set
    obj.select_set(boolien)
    return


def ShowMessageBoxer(title, icon, message):
    scene = bpy.context.scene
    # Access the 2D cursor location
    cursor_location = scene.cursor.location 

    def draw(self, context):
        self.layout.label(text=message)
    bpy.context.window_manager.popup_menu(draw, title=title, icon=icon)


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


@persistent
def depsgraph_update_pre_handler_E947C(dummy):
    if bpy.context.scene.sna_transformbooleantoggle:
        if (not (len(bpy.context.view_layer.objects.selected) == 0)):
            if 'Stamp' in bpy.context.view_layer.objects.active.name:
                if bpy.context.view_layer.objects.active.type == 'EMPTY':
                    bpy.context.scene.tool_settings.use_snap = True
                    bpy.context.scene.tool_settings.use_snap_align_rotation = True
                    bpy.context.scene.tool_settings.snap_elements = set(['FACE'])
                    bpy.context.scene.sna_transformboolean = True
            else:
                bpy.context.scene.tool_settings.use_snap = False


class SNA_OT_Select_Empty_F519E(bpy.types.Operator):
    bl_idname = "sna.select_empty_f519e"
    bl_label = "Select Empty"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_emptyid: bpy.props.StringProperty(name='EmptyID', description='', default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.ops.object.select_all('INVOKE_DEFAULT', action='DESELECT')
        bpy.context.view_layer.objects.active = bpy.data.objects[self.sna_emptyid]
        sna_object_select_set_ACDF7_55FB4(bpy.data.objects[self.sna_emptyid], True)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Replace_Image_457Cd(bpy.types.Operator, ImportHelper):
    bl_idname = "sna.replace_image_457cd"
    bl_label = "Replace Image"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    filter_glob: bpy.props.StringProperty( default='*.png;*.jpg;*.exr', options={'HIDDEN'} )
    sna_stampid: bpy.props.StringProperty(name='StampID', description='', default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        image_1C8AD = bpy.data.images.load(filepath=self.filepath, )
        bpy.context.view_layer.objects.active.material_slots[bpy.context.view_layer.objects.active.active_material.name].material.node_tree.nodes[self.sna_stampid].node_tree.nodes['STAMP IMAGE'].image = image_1C8AD
        IMGNAME = image_1C8AD.name
        EMPTY = self.sna_stampid
        # Ensure you have an image loaded in Blender with the name "YourImageNameHere"
        image_name = IMGNAME
        empty_name = EMPTY
        # Access the image
        image = bpy.data.images[image_name]
        # Calculate the aspect ratio of the image
        aspect_ratio = image.size[0] / image.size[1]  # Width divided by Height
        # Access the empty
        empty = bpy.data.objects[empty_name]
        # Apply the aspect ratio to the empty's scale
        # This example scales the empty's X dimension according to the aspect ratio,
        # and keeps Y and Z dimensions unchanged. Modify as needed.
        empty.scale.x = aspect_ratio * empty.scale.y
        print(f"Image Aspect Ratio: {aspect_ratio}")
        print(f"New Scale for {empty_name}: {empty.scale}")
        return {"FINISHED"}


class SNA_OT_Remove_Stamp_50725(bpy.types.Operator):
    bl_idname = "sna.remove_stamp_50725"
    bl_label = "Remove stamp"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_removeid: bpy.props.StringProperty(name='RemoveID', description='', default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.ops.node.group_edit('INVOKE_DEFAULT', exit=True)
        prev_context = bpy.context.area.type
        bpy.context.area.type = 'NODE_EDITOR'
        bpy.ops.node.select_all('INVOKE_DEFAULT', action='DESELECT')
        bpy.context.area.type = prev_context
        bpy.context.view_layer.objects.active.material_slots[bpy.context.view_layer.objects.active.active_material.name].material.node_tree.nodes[self.sna_removeid].select = True
        bpy.ops.node.delete_reconnect('INVOKE_DEFAULT', )
        bpy.data.objects.remove(object=bpy.data.objects[bpy.data.node_groups[self.sna_removeid].nodes['Texture Coordinate'].object.name], )
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Refresh_Stampids_1C058(bpy.types.Operator):
    bl_idname = "sna.refresh_stampids_1c058"
    bl_label = "Refresh StampID's"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        for i_94D87 in range(len(bpy.data.objects)):
            if (not (len(bpy.data.objects[i_94D87].material_slots) == 0)):
                bpy.ops.sna.stamp_it_ee8b7('INVOKE_DEFAULT', )
                bpy.ops.sna.remove_stamp_50725('INVOKE_DEFAULT', sna_removeid='')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Fix_Aspect_Ratio_71E1D(bpy.types.Operator):
    bl_idname = "sna.fix_aspect_ratio_71e1d"
    bl_label = "Fix Aspect Ratio"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_emptyid: bpy.props.StringProperty(name='EmptyID', description='', default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        IMGNAME = bpy.data.node_groups[self.sna_emptyid].nodes['STAMP IMAGE'].image.name
        EMPTY = self.sna_emptyid
        # Ensure you have an image loaded in Blender with the name "YourImageNameHere"
        image_name = IMGNAME
        empty_name = EMPTY
        # Access the image
        image = bpy.data.images[image_name]
        # Calculate the aspect ratio of the image
        aspect_ratio = image.size[0] / image.size[1]  # Width divided by Height
        # Access the empty
        empty = bpy.data.objects[empty_name]
        # Apply the aspect ratio to the empty's scale
        # This example scales the empty's X dimension according to the aspect ratio,
        # and keeps Y and Z dimensions unchanged. Modify as needed.
        empty.scale.x = aspect_ratio * empty.scale.y
        print(f"Image Aspect Ratio: {aspect_ratio}")
        print(f"New Scale for {empty_name}: {empty.scale}")
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_add_to_node_pt_active_node_generic_59218(self, context):
    if not ((not (property_exists("bpy.context.view_layer.objects.active.material_slots[bpy.context.view_layer.objects.active.active_material.name].material.node_tree.nodes", globals(), locals()) and 'Stamp' in bpy.context.view_layer.objects.active.material_slots[bpy.context.view_layer.objects.active.active_material.name].material.node_tree.nodes))):
        layout = self.layout
        layout.label(text="Don't rename stamps! It can break the addon.", icon_value=2)


class SNA_PT_STAMP_IT_46F1B(bpy.types.Panel):
    bl_label = 'Stamp It!'
    bl_idname = 'SNA_PT_STAMP_IT_46F1B'
    bl_space_type = 'NODE_EDITOR'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'Stamp It!'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        if (not (len(bpy.context.view_layer.objects.selected) == 0)):
            if bpy.context.view_layer.objects.active.type == 'MESH':
                box_7E696 = layout.box()
                box_7E696.alert = False
                box_7E696.enabled = True
                box_7E696.active = True
                box_7E696.use_property_split = False
                box_7E696.use_property_decorate = False
                box_7E696.alignment = 'Expand'.upper()
                box_7E696.scale_x = 1.0
                box_7E696.scale_y = 2.0
                if not True: box_7E696.operator_context = "EXEC_DEFAULT"
                op = box_7E696.operator('sna.stamp_it_ee8b7', text='Stamp It!', icon_value=317, emboss=True, depress=False)
        if (bpy.context.view_layer.objects.active.type == 'MESH' and (not (len(bpy.context.view_layer.objects.selected) == 0))):
            col_1D3FF = layout.column(heading='', align=False)
            col_1D3FF.alert = False
            col_1D3FF.enabled = True
            col_1D3FF.active = True
            col_1D3FF.use_property_split = False
            col_1D3FF.use_property_decorate = False
            col_1D3FF.scale_x = 1.0
            col_1D3FF.scale_y = 1.0
            col_1D3FF.alignment = 'Expand'.upper()
            col_1D3FF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            layout_function = col_1D3FF
            sna_stampuirow_9DE44(layout_function, 'Stamp')
            for i_9B3DF in range(10):
                layout_function = col_1D3FF
                sna_stampuirow_9DE44(layout_function, 'Stamp.00' + str(i_9B3DF))
            for i_F1BE1 in range(100):
                layout_function = col_1D3FF
                sna_stampuirow_9DE44(layout_function, 'Stamp.0' + str(i_F1BE1))
        else:
            layout.label(text='Select an object to stamp.', icon_value=0)
        if 'Stamp' in bpy.context.view_layer.objects.active.name:
            if (not (len(bpy.context.view_layer.objects.selected) == 0)):
                box_D86E2 = layout.box()
                box_D86E2.alert = False
                box_D86E2.enabled = True
                box_D86E2.active = True
                box_D86E2.use_property_split = False
                box_D86E2.use_property_decorate = False
                box_D86E2.alignment = 'Expand'.upper()
                box_D86E2.scale_x = 1.0
                box_D86E2.scale_y = 1.5
                if not True: box_D86E2.operator_context = "EXEC_DEFAULT"
                if bpy.context.view_layer.objects.active.type == 'EMPTY':
                    col_8723C = box_D86E2.column(heading='', align=False)
                    col_8723C.alert = False
                    col_8723C.enabled = True
                    col_8723C.active = True
                    col_8723C.use_property_split = False
                    col_8723C.use_property_decorate = False
                    col_8723C.scale_x = 1.0
                    col_8723C.scale_y = 1.0
                    col_8723C.alignment = 'Center'.upper()
                    col_8723C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_C0D4A = col_8723C.row(heading='', align=False)
                    row_C0D4A.alert = False
                    row_C0D4A.enabled = True
                    row_C0D4A.active = True
                    row_C0D4A.use_property_split = False
                    row_C0D4A.use_property_decorate = False
                    row_C0D4A.scale_x = 1.0
                    row_C0D4A.scale_y = 1.0
                    row_C0D4A.alignment = 'Center'.upper()
                    row_C0D4A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_C0D4A.label(text='Move the stamp in viewport to see effect.', icon_value=0)
        if 'Stamp' in bpy.context.view_layer.objects.active.name:
            if (not (len(bpy.context.view_layer.objects.selected) == 0)):
                if bpy.context.view_layer.objects.active.type == 'EMPTY':
                    col_FF78C = layout.column(heading='', align=False)
                    col_FF78C.alert = False
                    col_FF78C.enabled = True
                    col_FF78C.active = True
                    col_FF78C.use_property_split = False
                    col_FF78C.use_property_decorate = False
                    col_FF78C.scale_x = 1.0
                    col_FF78C.scale_y = 1.0
                    col_FF78C.alignment = 'Expand'.upper()
                    col_FF78C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_801E5 = col_FF78C.row(heading='', align=False)
                    row_801E5.alert = False
                    row_801E5.enabled = True
                    row_801E5.active = True
                    row_801E5.use_property_split = False
                    row_801E5.use_property_decorate = False
                    row_801E5.scale_x = 1.0
                    row_801E5.scale_y = 1.0
                    row_801E5.alignment = 'Center'.upper()
                    row_801E5.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_801E5.label(text='This is just the empty that controls the stamp position.', icon_value=0)
                    row_1C04E = col_FF78C.row(heading='', align=False)
                    row_1C04E.alert = False
                    row_1C04E.enabled = True
                    row_1C04E.active = True
                    row_1C04E.use_property_split = False
                    row_1C04E.use_property_decorate = False
                    row_1C04E.scale_x = 1.0
                    row_1C04E.scale_y = 1.0
                    row_1C04E.alignment = 'Center'.upper()
                    row_1C04E.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_1C04E.label(text='To change or delete the stamp, select the object that the stamp is applied to.', icon_value=0)


class SNA_OT_Stamp_It_Ee8B7(bpy.types.Operator):
    bl_idname = "sna.stamp_it_ee8b7"
    bl_label = "Stamp It"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if (not (len(bpy.context.view_layer.objects.selected[0].material_slots) == 0)):
            BlendFilePath = os.path.join(os.path.dirname(__file__), 'assets', 'NodeGroups.blend')
            NodeGroupName = 'Stamp'
            empty_cube_name = None
            appended_node_group_name = None
            active_object = None
            # Function to generate a unique name for the empty

            def generate_unique_name(base_name, existing_names):
                i = 1
                new_name = f"{base_name}{i}"
                while new_name in existing_names:
                    i += 1
                    new_name = f"{base_name}{i}"
                return new_name
            # Step 0: Setup and validations
            blend_file_path = BlendFilePath
            node_group_name = NodeGroupName
            existing_objects = set(bpy.data.objects.keys())
            existing_node_groups = set(bpy.data.node_groups.keys())
            # Store the currently active object
            active_object = bpy.context.view_layer.objects.active
            # Create an empty without specifying the location in the add operation
            bpy.ops.object.empty_add(type='CUBE')
            empty_cube = bpy.context.active_object
            # Explicitly set the empty's location to the 3D cursor's location
            empty_cube.location = bpy.context.scene.cursor.location
            # Set the empty's scale to 1m x 1m x 1m
            empty_cube.scale = (0.25, 0.25, 0.25)  # Adjust the scale to 1mx1mx1m
            empty_cube_name = generate_unique_name("Stamp", existing_objects)
            empty_cube.name = empty_cube_name
            empty_cube.parent = active_object
            # Step 2: Append a node group from a .blend file
            with bpy.data.libraries.load(blend_file_path, link=False) as (data_from, data_to):
                data_to.node_groups = [name for name in data_from.node_groups if name == node_group_name]
            # Ensuring the node group was appended and get its new name
            appended_node_groups = [name for name in bpy.data.node_groups.keys() if name not in existing_node_groups]
            if appended_node_groups:
                appended_node_group_name = appended_node_groups[0]  # Assuming the first one is what we want
            else:
                print(f"Node group '{node_group_name}' was not found.")
                appended_node_group_name = None
            # Step 3: Insert the node group into the active material, link nodes, and set the texture coordinate
            if appended_node_group_name:
                material = active_object.material_slots[0].material
                if material.use_nodes:
                    nodes = material.node_tree.nodes
                    links = material.node_tree.links
                    # Create and link the node group
                    node_group_instance = nodes.new(type='ShaderNodeGroup')
                    node_group_instance.node_tree = bpy.data.node_groups[appended_node_group_name]
                    # Set the name and label of the node group instance
                    node_group_instance.name = appended_node_group_name
                    node_group_instance.label = appended_node_group_name
                    # Find the Material Output node
                    material_output = nodes.get("Material Output")
                    if material_output:
                        # Assuming the node connected to the Surface socket is the "last" node
                        if material_output.inputs['Surface'].is_linked:
                            last_node = material_output.inputs['Surface'].links[0].from_node
                            # Offset the new node group to the right of the last node
                            node_group_instance.location.x = last_node.location.x + 200  # Adjust the offset as needed
                            node_group_instance.location.y = last_node.location.y
                        # Link the node group if there's a suitable connection point
                        if material_output.inputs['Surface'].is_linked:
                            surface_input = material_output.inputs['Surface'].links[0].from_node
                            links.new(surface_input.outputs[0], node_group_instance.inputs[0])
                            links.new(node_group_instance.outputs[0], material_output.inputs['Surface'])
                        # Set the object pointer in the Texture Coordinate node inside the node group
                        for node in node_group_instance.node_tree.nodes:
                            if node.type == 'TEX_COORD':
                                node.object = empty_cube
                                break
            else:
                print("No node group was appended.")
            bpy.data.objects[empty_cube_name].name = appended_node_group_name
            prev_context = bpy.context.area.type
            bpy.context.area.type = 'VIEW_3D'
            bpy.ops.view3d.snap_selected_to_cursor('INVOKE_DEFAULT', )
            bpy.context.area.type = prev_context
            image_A321B = bpy.data.images.load(filepath=os.path.join(os.path.dirname(__file__), 'assets', 'PngStamp.png'), check_existing=True, )
            active_object.material_slots[active_object.active_material.name].material.node_tree.nodes[appended_node_group_name].node_tree.nodes['STAMP IMAGE'].image = bpy.data.images['PngStamp.png']
            if property_exists("bpy.data.images['PngStamp.png']", globals(), locals()):
                if property_exists("bpy.data.images['PngStamp.png.001']", globals(), locals()):
                    bpy.data.images.remove(image=bpy.data.images['PngStamp.png.001'], )
        else:
            ShowMessageBoxer('Warning',
                                                              'FUND',
                                                              'Object has no material')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_stampuirow_9DE44(layout_function, nodeexists):
    if (not (len(bpy.context.view_layer.objects.selected[0].material_slots) == 0)):
        if (property_exists("bpy.context.view_layer.objects.active.material_slots[bpy.context.view_layer.objects.active.active_material.name].material.node_tree.nodes", globals(), locals()) and nodeexists in bpy.context.view_layer.objects.active.material_slots[bpy.context.view_layer.objects.active.active_material.name].material.node_tree.nodes):
            row_2045B = layout_function.row(heading='', align=False)
            row_2045B.alert = False
            row_2045B.enabled = True
            row_2045B.active = True
            row_2045B.use_property_split = False
            row_2045B.use_property_decorate = False
            row_2045B.scale_x = 1.0
            row_2045B.scale_y = 1.0
            row_2045B.alignment = 'Expand'.upper()
            row_2045B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            box_CBB5C = row_2045B.box()
            box_CBB5C.alert = False
            box_CBB5C.enabled = True
            box_CBB5C.active = True
            box_CBB5C.use_property_split = False
            box_CBB5C.use_property_decorate = False
            box_CBB5C.alignment = 'Expand'.upper()
            box_CBB5C.scale_x = 1.0
            box_CBB5C.scale_y = 1.0
            if not True: box_CBB5C.operator_context = "EXEC_DEFAULT"
            row_701BD = box_CBB5C.row(heading='', align=False)
            row_701BD.alert = False
            row_701BD.enabled = True
            row_701BD.active = True
            row_701BD.use_property_split = False
            row_701BD.use_property_decorate = False
            row_701BD.scale_x = 1.0
            row_701BD.scale_y = 1.0
            row_701BD.alignment = 'Expand'.upper()
            row_701BD.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            row_701BD.prop(bpy.context.view_layer.objects.active.material_slots[bpy.context.view_layer.objects.active.active_material.name].material.node_tree.nodes[nodeexists].node_tree.nodes['STAMP IMAGE'], 'image', text=nodeexists, icon_value=0, emboss=True)
            row_707D0 = box_CBB5C.row(heading='', align=False)
            row_707D0.alert = False
            row_707D0.enabled = True
            row_707D0.active = True
            row_707D0.use_property_split = False
            row_707D0.use_property_decorate = False
            row_707D0.scale_x = 3.6399998664855957
            row_707D0.scale_y = 1.3300000429153442
            row_707D0.alignment = 'Center'.upper()
            row_707D0.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = row_707D0.operator('sna.select_empty_f519e', text='', icon_value=256, emboss=True, depress=False)
            op.sna_emptyid = nodeexists
            op = row_707D0.operator('sna.replace_image_457cd', text='', icon_value=693, emboss=True, depress=False)
            op.sna_stampid = nodeexists
            op = row_707D0.operator('sna.fix_aspect_ratio_71e1d', text='', icon_value=692, emboss=True, depress=False)
            op.sna_emptyid = nodeexists
            op = row_707D0.operator('sna.remove_stamp_50725', text='', icon_value=21, emboss=True, depress=False)
            op.sna_removeid = nodeexists


class SNA_PT_SETTINGS_9533B(bpy.types.Panel):
    bl_label = 'Settings'
    bl_idname = 'SNA_PT_SETTINGS_9533B'
    bl_space_type = 'NODE_EDITOR'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'Stamp It!'
    bl_order = 1
    bl_options = {'DEFAULT_CLOSED'}
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout
        layout.label(text='', icon_value=92)

    def draw(self, context):
        layout = self.layout
        layout.prop(bpy.context.scene, 'sna_transformbooleantoggle', text='Stamps Auto Stick To Surfaces', icon_value=0, emboss=True)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_storedpointer = bpy.props.PointerProperty(name='StoredPointer', description='', type=bpy.types.Object)
    bpy.types.Scene.sna_storedgroupname = bpy.props.StringProperty(name='StoredGroupName', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_storedemptypointer = bpy.props.PointerProperty(name='StoredEmptyPointer', description='', type=bpy.types.Object)
    bpy.types.Scene.sna_texturecoordname = bpy.props.StringProperty(name='TextureCoordName', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_oldnodename = bpy.props.StringProperty(name='OldNodeName', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_imageholder = bpy.props.PointerProperty(name='ImageHolder', description='', type=bpy.types.Image)
    bpy.types.Scene.sna_storeparent = bpy.props.PointerProperty(name='StoreParent', description='', type=bpy.types.Object)
    bpy.types.Object.sna_is_parented = bpy.props.BoolProperty(name='Is Parented', description='', default=True)
    bpy.types.Scene.sna_transformboolean = bpy.props.BoolProperty(name='TransformBoolean', description='', default=False)
    bpy.types.Scene.sna_emptyrenamepointer = bpy.props.PointerProperty(name='EmptyRenamePointer', description='', type=bpy.types.Object)
    bpy.types.Scene.sna_transformbooleantoggle = bpy.props.BoolProperty(name='TransformBooleanToggle', description='', default=True)
    bpy.app.handlers.depsgraph_update_pre.append(depsgraph_update_pre_handler_E947C)
    bpy.utils.register_class(SNA_OT_Select_Empty_F519E)
    bpy.utils.register_class(SNA_OT_Replace_Image_457Cd)
    bpy.utils.register_class(SNA_OT_Remove_Stamp_50725)
    bpy.utils.register_class(SNA_OT_Refresh_Stampids_1C058)
    bpy.utils.register_class(SNA_OT_Fix_Aspect_Ratio_71E1D)
    bpy.types.NODE_PT_active_node_generic.prepend(sna_add_to_node_pt_active_node_generic_59218)
    bpy.utils.register_class(SNA_PT_STAMP_IT_46F1B)
    bpy.utils.register_class(SNA_OT_Stamp_It_Ee8B7)
    bpy.utils.register_class(SNA_PT_SETTINGS_9533B)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_transformbooleantoggle
    del bpy.types.Scene.sna_emptyrenamepointer
    del bpy.types.Scene.sna_transformboolean
    del bpy.types.Object.sna_is_parented
    del bpy.types.Scene.sna_storeparent
    del bpy.types.Scene.sna_imageholder
    del bpy.types.Scene.sna_oldnodename
    del bpy.types.Scene.sna_texturecoordname
    del bpy.types.Scene.sna_storedemptypointer
    del bpy.types.Scene.sna_storedgroupname
    del bpy.types.Scene.sna_storedpointer
    bpy.app.handlers.depsgraph_update_pre.remove(depsgraph_update_pre_handler_E947C)
    bpy.utils.unregister_class(SNA_OT_Select_Empty_F519E)
    bpy.utils.unregister_class(SNA_OT_Replace_Image_457Cd)
    bpy.utils.unregister_class(SNA_OT_Remove_Stamp_50725)
    bpy.utils.unregister_class(SNA_OT_Refresh_Stampids_1C058)
    bpy.utils.unregister_class(SNA_OT_Fix_Aspect_Ratio_71E1D)
    bpy.types.NODE_PT_active_node_generic.remove(sna_add_to_node_pt_active_node_generic_59218)
    bpy.utils.unregister_class(SNA_PT_STAMP_IT_46F1B)
    bpy.utils.unregister_class(SNA_OT_Stamp_It_Ee8B7)
    bpy.utils.unregister_class(SNA_PT_SETTINGS_9533B)
